// C Source File
// Created 09.01.2004; 16:00:46

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Place your comment here."
#define COMMENT_PROGRAM_NAME   "Place your program name here."
#define COMMENT_VERSION_NUMBER 0,0,0,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>
//#include <extgraph.h>

//****************************************************************************

#ifndef __GRAY3P
#include "gray3P.h"
#endif

//****************************************************************************

#define MAX_X LCD_WIDTH
#define MAX_Y LCD_HEIGHT

#define PI2 (6.283185307) 
#define PIH (1.570796327) 

#define PI_K 314 
#define PI2_K 628
#define PIH_K 157
#define PI12_K 26

#define MAP_SIZE 254
#define MAP_SIZE1 253
#define MAP_SIZE100 25400
#define MAP_SIZE2 64516
#define F 5

#define RAY_COUNT 12800
// RAY_COUNT = 160 *80

const unsigned char bit_table[8]={0x80,0x40,0x20,0x10,0x8,0x4,0x2,0x1};

//****************************************************************************

struct point3d_i_type
{
	short x, y, z;
};

//****************************************************************************

unsigned short i, j, k, u;
short					 is, js, ks, x, y, z, xo, yo, zo, xoo, yoo, xs, ys, zs, xn, yn, zn, s;
short					 map_buf, map_buf_fin, horizon, details, mod;
long					 l, w;
unsigned short ch, pos, pos2, pos3;
unsigned char  b, txt[40], interlace;
unsigned char  win_x1, win_y1, win_x2, win_y2;
unsigned short *ray_map_ofs_p;
unsigned char  *map_data_p, *ray_map_siz_p, *ray_map_x_p;
unsigned char  *lightp_p, *mediump_p, *darkp_p;
SCR_RECT			 full_screen = {{0, 0, 159, 99}};
BOOL					 q_7or8grays;

struct point3d_i_type movement;
struct point3d_i_type cam;

//****************************************************************************

#include "pixel.h"

//****************************************************************************
//****************************************************************************
//****************************************************************************

#define ASM_SWAP(val) ({\
    register unsigned long tmp = val;\
    asm volatile ("swap %0" : "=d" (tmp) : "0" (tmp));\
    tmp;})

/*===========================================================================*/
/* draws a horizontal line from (x1,y) to (x2,y) in given plane              */
/*                                                                           */
/* valid modes: A_REPLACE,A_NORMAL,A_REVERSE,A_XOR                           */
/*===========================================================================*/
void FastDrawHLine(unsigned char* plane,short x1,short x2,short y,short mode) {
    static const unsigned short table1[16] = {0xffff,0x7fff,0x3fff,0x1fff,
                                              0x0fff,0x07ff,0x03ff,0x01ff,
                                              0x00ff,0x007f,0x003f,0x001f,
                                              0x000f,0x0007,0x0003,0x0001};
    static const unsigned short table2[16] = {0x0000,0x8000,0xc000,0xe000,
                                              0xf000,0xf800,0xfc00,0xfe00,
                                              0xff00,0xff80,0xffc0,0xffe0,
                                              0xfff0,0xfff8,0xfffc,0xfffe};
    short           dx;
    short           sx;
    unsigned short* p;

    if (x1>x2) {
        short tmp = x1;
        x1 = x2;
        x2 = tmp;
    }

    p  = (unsigned short*)(plane+(y<<5)-(y<<1)+((x1>>3)&0x1e));
    dx = x2-x1+1;
    sx = x1 & 0x000f;

    if (dx<16) {
        unsigned long val = (ASM_SWAP(table2[dx])) >> sx;
        if (mode == A_REPLACE || mode == A_NORMAL) {
            *(unsigned long*)p |= val;
        }
        else if (mode == A_REVERSE) {
            *(unsigned long*)p &= ~val;
        }
        else if (mode == A_XOR) {
            *(unsigned long*)p ^= val;
        }
        return;
    }

    if (mode == A_REPLACE || mode == A_NORMAL) {
        if (sx) {
            *p++ |= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ |= 0xffff;
            dx-=16;
        }
        if (dx) *p |= table2[dx];
    }
    else if (mode == A_REVERSE) {
        if (sx) {
            *p++ &= ~(table1[sx]);
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ &= 0x0;
            dx-=16;
        }
        if (dx) *p &= ~(table2[dx]);
    }
    else if (mode == A_XOR) {
        if (sx) {
            *p++ ^= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ ^= 0xffff;
            dx-=16;
        }
        if (dx) *p ^= table2[dx];
    }
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void clrscr_gr (short delay)
{
	long l;
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void print_title (short x, short y)
{
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawStr(x+0, y+1, txt, A_NORMAL);
																 DrawStr(x+1, y+0, txt, A_NORMAL);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);  DrawStr(x+1, y+0, txt, A_NORMAL);
																 DrawStr(x+2, y+0, txt, A_NORMAL);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void check_keys (void)
{
		if (kbhit())
		{
			ch = ngetchx();
			if (ch >= 0x800) ch -= 0x800;

			if (ch == '+') if (details<20) details++; 
			if (ch == '-') if (details>1) details--; 
				
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void adjust(short xa, short ya, short x, short y, short xb, short yb)

{
  short d;
  float v;

  if (map_data_p[(unsigned)(x)+(y)*MAP_SIZE] != 0) return(0);
  d = abs (xa -xb) + abs (ya -yb);
  v = (map_data_p[(unsigned)(xa)+(ya)*MAP_SIZE] +map_data_p[(unsigned)(xb)+(yb)*MAP_SIZE]) /2 +
      ((random(101) -50) *d *F) /100;
  if (v < 1) v = 1;
  if (v > 255) v = 255;
  map_data_p[(unsigned)(x)+(y)*MAP_SIZE] = (unsigned char) trunc (v);
}

//****************************************************************************

void sub_divide (short x1, short y1, short x2, short y2, short quite)
{
	short x, y;
  float v;
      
  if ((x2 -x1 < 2) && (y2 -y1 < 2)) return (0);

  x = (x1 +x2) /2;
  y = (y1 +y2) /2;

  adjust (x1,y1,x,y1,x2,y1);
  adjust (x2,y1,x2,y,x2,y2);
  adjust (x1,y2,x,y2,x2,y2);
  adjust (x1,y1,x1,y,x1,y2);

  if (map_data_p[(unsigned)(x)+(y)*MAP_SIZE] == 0)
  {
    v = (map_data_p[(unsigned)(x1)+(y1)*MAP_SIZE] +map_data_p[(unsigned)(x2)+(y1)*MAP_SIZE] +
    	   map_data_p[(unsigned)(x2)+(y2)*MAP_SIZE] +map_data_p[(unsigned)(x1)+(y2)*MAP_SIZE]) /4;
    i = map_data_p[(unsigned)(x)+(y)*MAP_SIZE] = (unsigned char) trunc (v);
/*		
		if (x < 16)	map_data_p[(unsigned)(MAP_SIZE1-x)+(y)*MAP_SIZE] = 255;
		if (y < 16)	map_data_p[(unsigned)(x)+(MAP_SIZE1-y)*MAP_SIZE] = 255;
*/	
		if (quite > 0) 
		{
			xs = x /3 +38; ys = y /3 +11;
 			Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 	 		if (i < 128) 		 DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
			Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (i %128 < 64) DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
   		Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	  	if (i %64 < 32)	 DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
		}
		else
  	if (is %100 == 0)
		{
			ScrRectFill (&(SCR_RECT){{0, 91, is /131, 99}}, &full_screen , A_NORMAL); 
			ScrRectFill (&(SCR_RECT){{is /131 +1, 91, 159, 99}}, &full_screen , A_REVERSE); 
			sprintf (txt, "Loading... %d%%", is /208); DrawStr (38, 92, txt, A_XOR);
		}
		is++;
	}

  sub_divide(x1,y1,x,y,quite);
  sub_divide(x,y1,x2,y,quite);
  sub_divide(x,y,x2,y2,quite);
  sub_divide(x1,y,x,y2,quite);
}

//****************************************************************************

void generate_map (float f, short quite)
{
	if (quite > 0) clrscr_gr (1);
	
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	FontSetSys (F_6x8);
	if (f == 1)
	{	sprintf (txt, "Generating %f Voxels...", (float) MAP_SIZE*MAP_SIZE);
		srand (0); //0 to 4294967295
	}
	else
	{	sprintf (txt, "Map-ID: %f", (float) f);
		srand ((unsigned long) f); //0 to 4294967295
	}
	if (quite > 0) DrawStr (0, 0, txt, A_NORMAL);

	for (i = 0; i < MAP_SIZE; i += 1)
 		for (j = 0; j < MAP_SIZE; j += 1)
  	{
			map_data_p[(i)+(j)*MAP_SIZE] = 0;
		}
 	map_data_p[(0)+(0)*MAP_SIZE] = random(255) +1;
  map_data_p[(253)+(0)*MAP_SIZE] = random(255) +1;
  map_data_p[(253)+(253)*MAP_SIZE] = random(255) +1;
  map_data_p[(0)+(253)*MAP_SIZE] = random(255) +1;
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	is = 0;
	sub_divide(0,0,253,253,quite); // plasma
	
	clrscr_gr (1);

	for (i=0; i<MAP_SIZE; i += 1)
 		for (j = MAP_SIZE -2; j>=1; j -= 1)
  	{
	 		xs = j/2 -i/8 +31;
 		 	ys = i/4 - (u = map_data_p[(i)+(j)*MAP_SIZE]) /16 +35;
 		
 		  if (u <= map_data_p[(i-1)+(j)*MAP_SIZE]) u = u *3 /4 +32;
 		  else 																		 u = u *3 /4;
 			
			if (u < 128) 		 FastDrawHLine (Gray3PGetPlane (GRAY3P_DARK_PLANE), xs, xs+1, ys, A_NORMAL);
  		else 						 FastDrawHLine (Gray3PGetPlane (GRAY3P_DARK_PLANE), xs, xs+1, ys, A_REVERSE);
			if (u %128 < 64) FastDrawHLine (Gray3PGetPlane (GRAY3P_MEDIUM_PLANE), xs, xs+1, ys, A_NORMAL);
			else 						 FastDrawHLine (Gray3PGetPlane (GRAY3P_MEDIUM_PLANE), xs, xs+1, ys, A_REVERSE);
   		if (u %64 < 32)	 FastDrawHLine (Gray3PGetPlane (GRAY3P_LIGHT_PLANE), xs, xs+1, ys, A_NORMAL);
  		else 						 FastDrawHLine (Gray3PGetPlane (GRAY3P_LIGHT_PLANE), xs, xs+1, ys, A_REVERSE);
 		}

	ngetchx();
	clrscr_gr (1);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

// Main Function
void _main(void)
{
  map_data_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZE);
	ray_map_ofs_p = (unsigned short *) malloc ((unsigned short) sizeof(short) *RAY_COUNT);
	ray_map_siz_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *RAY_COUNT);
	ray_map_x_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *RAY_COUNT);
	
	q_7or8grays = TRUE; 
  if (!Gray3POn (TRUE)) // 7 shades mode
    return;
	q_7or8grays = !q_7or8grays; Gray3POff (); Gray3POn (q_7or8grays); // hide this line for final production compilation!

	clrscr_gr (0);

	FontSetSys (F_6x8);
	for (is=3, k=0; (is < 160); is += 4) // screen width, no need for changes!
  {
 		for (js=0; (js < 80); js++, k++) // depth
  	{
			x = ((is -80) *js) /80;
			y = js;
			ray_map_ofs_p[k] = -y +x *MAP_SIZE; 	 	  
			ray_map_siz_p[k] = y +1; 	 	  
			ray_map_x_p[k] = is;
   	}
  ScrRectFill (&(SCR_RECT){{0, 91, is, 99}}, &full_screen , A_NORMAL); 
	ScrRectFill (&(SCR_RECT){{is +1, 91, 159, 99}}, &full_screen , A_REVERSE); 
	sprintf (txt, "Loading... %d%%", (is +1) *10 /16); DrawStr (38, 92, txt, A_XOR);
	}

	generate_map (1, 0);
	
//****************************************************************************
	clrscr_gr (0);
	if (!kbhit()) for (w=0; w<500000; w++); //wait
	
	srand(1);

	FontSetSys(F_6x8);
	sprintf (txt, "Kai Kostack"); print_title (45, 45);
	title(); clrscr_gr (0);
	FontSetSys(F_6x8);
	sprintf (txt, "presents"); print_title (55, 45);
	title(); clrscr_gr (0);
	FontSetSys(F_8x10);
	sprintf (txt, "VOXELSPACE");	print_title (35, 45);
	title(); clrscr_gr(0);
	FontSetSys(F_6x8);
	sprintf (txt, "The Game Demo"); print_title (35, 45);
	title(); clrscr_gr (0);
	GKeyFlush();
							
//****************************************************************************
	cam.x = 250 *100;
	cam.y = 125 *100; 	 	  
	cam.z = 220 *100;
	movement.x = 0 -100; movement.y = 0 -50; movement.z = 0;
	horizon = 25;
	
	details = 2;

//****************************************************************************
menu:
ch = 1;
while ((ch != KEY_ESC) && (ch != '1') && (ch != '2'))
{
	clrscr_gr (1);

	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{30, 10, 159-10, 99-30}}, &full_screen , A_NORMAL); 
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);  ScrRectFill (&(SCR_RECT){{10, 30, 159-30, 99-10}}, &full_screen , A_NORMAL); 

	FontSetSys (F_6x8);
	sprintf (txt, "What to do?"); DrawStr (31, 12, txt, A_NORMAL);
	sprintf (txt, "[1] Render"); DrawStr (39, 35, txt, A_REVERSE);
	sprintf (txt, "[2] New map"); DrawStr (39, 47, txt, A_REVERSE);
	FontSetSys (F_4x6);
	sprintf (txt, "VOXELSPACE - Technology Demo v2.0"); DrawStr (29, 2, txt, A_NORMAL);
	sprintf (txt, "For more 3D CGI visit"); DrawStr (32, 73, txt, A_REVERSE);
	sprintf (txt, "www.KaiKostack.com"); DrawStr (52, 81, txt, A_REVERSE);
	sprintf (txt, "Copyright (C) 2004 by Kai Kostack"); DrawStr (9, 93, txt, A_NORMAL);
	ch = 1;
	while ((ch != KEY_ESC) && (ch != '1') && (ch != '2')) ch = ngetchx();
	if (ch == '2') { randomize();
									 generate_map ((float) random(32767) *32767 +random(32767), 1);
									 ngetchx(); }
}
if (ch == KEY_ESC) goto quit;

//****************************************************************************
	clrscr_gr (3);

//  OSFastArrows = 2;
	ch = 1;
	interlace = 0;
	while (ch!=KEY_ESC)
	{
		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		ScrRectFill (&(SCR_RECT){{0, 69, 159, 99}}, &full_screen , A_NORMAL); 
		FontSetSys (F_4x6);
		sprintf (txt, "%f %f %f %f  ", (float) cam.x, (float) cam.y, (float) cam.z, (float) horizon); DrawStr (0, 100-6*5, txt, A_REVERSE);
		sprintf (txt, "[+],[-] World detail: %f", (float) details); DrawStr (0, 100-6*1, txt, A_REVERSE);
		
	  cam.x += movement.x; 	 	  
		cam.y += movement.y; 	 	  
//		cam.z += movement.z;
		if (cam.x < 0) cam.x += MAP_SIZE100; if (cam.x >= MAP_SIZE100) cam.x -= MAP_SIZE100;
		if (cam.y < 0) cam.y += MAP_SIZE100; if (cam.y >= MAP_SIZE100) cam.y -= MAP_SIZE100;
		if (cam.z < 0) cam.z += MAP_SIZE100; if (cam.z >= 25600) cam.z -= MAP_SIZE100;
/*		if ((cam.y <= 50 *100) || (cam.y >= 200 *100))
		{ movement.x = -movement.x;	movement.y = -movement.y; movement.z = -movement.z;	}	 	  
*/	
		xn = cam.x /100;
		yn = cam.y /100;
		zn = cam.z /100;
//		pos2 = (xn+80) +(yn-80) *250;
//		cam.z = ((long) cam.z + (map_data_p[pos2] +40) *100) /2;
//		pos2 = (xn+80) +(yn-80) *250;
		pos2 = xn +yn *MAP_SIZE;
		zn = ((short) map_data_p[pos2] +map_data_p[pos2-20] +map_data_p[pos2+20]) /3 +50;
		
		lightp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_LIGHT_PLANE);
		mediump_p = (unsigned char *) Gray3PGetPlane (GRAY3P_MEDIUM_PLANE);
		darkp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_DARK_PLANE);
		win_x1 = 0; win_x2 = 39; win_y1 = 3; win_y2 = 67;
	 	ks = win_x2 *80 +80;
		xs = -1;
		for (k = win_x1 *80 +80; k < ks; k += details)
 		{ 
			if ((k +(interlace *80)) %160 < 80) k += 80; 
		
			xoo = xo;
			xo = xs;
			xs = ray_map_x_p[k];
			if (xs != xo) { yoo = yo; yo = ys; ys = win_y2; }
			
			if (yo > win_y1)
			{
				pos = (long) ray_map_ofs_p[k] +pos2;
				if (pos >= MAP_SIZE2)	pos = pos -MAP_SIZE2;
				
				map_buf_fin = map_data_p[pos];
				yo = ys;
   			ys = horizon +(((long) (zn -map_buf_fin) *10) /ray_map_siz_p[k]);
				if (ys < win_y1) ys = win_y1;
			
				if (ys > yo) ys = yo;
				
				if ((ys < yo) && (k < ks -80))
				{
					 	u = map_data_p[pos -1];
					  if (u <= map_buf_fin) u = u *3 /4 +32;
  					else 									u = u *3 /4;
 		  			
						if (interlace == 0)
						{
							for (i = 0, j = yo -ys -1; (i <= j); i++)
							{
								pos3 = (xs /8) +(yo -i) *30;
								
 								if (u < 128) 		 darkp_p[pos3] |= 0x0f;	 
								else 						 darkp_p[pos3] &= 0xf0;
								if (u %128 < 64) mediump_p[pos3] |= 0x0f;	
								else 						 mediump_p[pos3] &= 0xf0;
								if (u %64 < 32)	 lightp_p[pos3] |= 0x0f;	
								else 						 lightp_p[pos3] &= 0xf0;
							}
						}
						else
						{
							for (i = 0, j = yo -ys -1; (i <= j); i++)
							{
								pos3 = (xs /8) +(yo -i) *30;
 		  					
 								if (u < 128) 		 darkp_p[pos3] |= 0xf0;	 
								else 						 darkp_p[pos3] &= 0x0f;
								if (u %128 < 64) mediump_p[pos3] |= 0xf0;	
								else 						 mediump_p[pos3] &= 0x0f;
								if (u %64 < 32)	 lightp_p[pos3] |= 0xf0;	
								else 						 lightp_p[pos3] &= 0x0f;
							}
						}
				}
			}
			if (xs != xo) // draws the sky
			{
				if (yoo < win_y1) yoo = win_y1;
				if ((yoo < win_y2) && (k > 160))
				for (i = 1, j = yoo -win_y1; (i < j); i++)
				{
					pos3 = (xoo /8) +(yoo -i) *30;

					if (interlace == 0)
					{	darkp_p[pos3] &= 0xf0; mediump_p[pos3] &= 0xf0; lightp_p[pos3] &= 0xf0; }
					else
					{ darkp_p[pos3] &= 0x0f; mediump_p[pos3] &= 0x0f; lightp_p[pos3] &= 0x0f; }
				}
			}
		}
	
		check_keys();
	
		if (interlace < 1) interlace++; else interlace = 0;
	}
	clrscr_gr (1);
 	goto menu;

 	quit:
  free (map_data_p);
  free (ray_map_ofs_p);
 	free (ray_map_siz_p);
 	free (ray_map_x_p);
  Gray3POff ();
}
